/* fine STAYOPEN        /* Don't open/close decriptors all the time */

#include <stdio.h>
#include <signal.h>
#include <ctype.h>
#include <pwd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <local/cmd.h>
#include <local/camac.h>

extern struct module    *_seekmodule(), *_askfor_module(), *_modopen(), *_convadm();
#define ERR_RETURN      0xffffffff
#define SUC_RETURN      0xabcd

#ifndef FALSE
#define FALSE           0
#endif  FALSE
#ifndef TRUE
#define TRUE            1
#endif  TRUE

#define ASK_MOD      FALSE
#define ASK_RAW       TRUE

#define MAXBUFFER   0x1000      /* Max access size in bytes                 */
#define MAXNAME         16      /* Max name of installed modules            */
#define MAXSTRING      256
#define MAXLOG          16      /* Max nr of modules logged                 */
#define MAXCAM_A        15      /* Highest A of camac                       */
#define MAXCAM_F        31      /* Highest F of camac                       */

#define MAXCRATE         4      /* Configured for 3 crates                  */
#define MAXSLOT         32      /* Module slots per crate                   */
#define MAXMOD   (MAXCRATE*MAXSLOT)  /* Module slots per branch             */

#define CAMCMD_READ         1
#define CAMCMD_WRITE        2
#define CAMCMD_LAMENA       3
#define CAMCMD_LAMDIS       4
#define CAMCMD_LAM          5
#define CAMCMD_RESP_READ    6
#define CAMCMD_RESP_WRITE   7

	/*
********** Declaration part cmd **********************************************
	**
	**      Declaration of cmdlists.
	*/
ACTION  v_show(),       v_install(),    v_shut(),       v_start();
ACTION  v_camac(),      v_remove(),     v_verbose(),    v_lam();
ACTION  v_loop(),       v_response(),   v_history();

CMDLIST Cam_cmds =
{
	{"CAM",                 NULL            },
	{"show",                v_show          },
	{"shut",                v_shut          },
	{"start",               v_start         },
	{"install",             v_install       },
	{"remove",              v_remove        },
	{"camac",               v_camac         },
	{"lam",                 v_lam           },
	{"verbose",             v_verbose       },
	{"loop",                v_loop          },
	{"response",            v_response      },
	{"history",             v_history       },
	{NULL,                  NULL            }
};

	/*
********** Declaration part camcmd *******************************************
	**
	*/

struct  module
{       /* The module    used in Cam_mod and Cam_log */
	char            df_name[MAXNAME];
	char            df_user[MAXNAME];
	time_t          df_time;
	unsigned int    df_busy;        /* Means installed module       */
	unsigned int    df_crate;
	unsigned int    df_slot;
	/* Actual state  only used in Cam_mod        */
	unsigned int    df_descr;
	unsigned int    df_lam;
	/* The arguments used in Cam_mod and Cam_log */
	unsigned int    df_func;
	unsigned int    df_addr;
	unsigned int    df_data;
	unsigned int    df_data_mask;
	unsigned int    df_resp_data;
	unsigned int    df_stat_mask;
	unsigned int    df_resp_stat;
	/* The history   only used in Cam_log        */
	unsigned int    df_stat;        /* Status after access          */
	unsigned int    df_action;      /* Kind of action               */
	unsigned int    df_number;      /* Uniq history number          */
};

struct module  Cam_mod[MAXCRATE * MAXSLOT];
struct module  Cam_log[MAXLOG];
struct module  Cam_lam;

unsigned long  Lam_seen                 = {FALSE};
unsigned long  Cam_print                = {TRUE}; /* Verbosity on       */
unsigned long  Cam_logindex             = {0};  /* Relative log index   */
unsigned long  Cam_history              = {0};  /* Uniq history number  */
unsigned long  Def_hist_from            = {0};
unsigned long  Def_hist_until           = {0};
unsigned long  Def_hist_times           = {1};
unsigned long  Def_modulekey            = {0};
unsigned long  Def_crate                = {1};
unsigned long  Def_slot                 = {1};
unsigned short Cam_buffer   [MAXBUFFER];
	 char  Cam_rawstr   [MAXNAME]   = {"raw"};

extern int _cam_sig();

	/*
********** Main procedure  camcmd ********************************************
	**
	*/

main    (argc, argv)
int     argc;
char   *argv[];
{
	extern INDEX	Outm_index;
	extern CMDLIST  Cam_cmds;
	       ACTION   status;
	       char     machine_name[80];

	Outm_index   = KEY_DECIMAL;
	Bprompt      = "<"  ;
	Bquestion    = "-"  ;
	Bmessage     = " * ";
	map_to_lower = FALSE;
	Cam_verbose  = CAM_SILENT;

	signal(SIGCAM, _cam_sig);
	_cammod_init();

	while  (command(Cam_cmds) != STOP);
} /* end main */


_cam_sig()
{
	printf("--> CAMAC LAM <--\n");
	fflush(stdout);
	Lam_seen = TRUE;
	signal(SIGCAM, _cam_sig);
}

	struct module *
_askfor_module(rawflag)
{
	ACTION         status;
	int            mod_index;
	struct module *modptr;
	char          *mod_key[MAXMOD];

	if (_mod_to_key(mod_key, rawflag) == ERR_RETURN)
	    return((struct module *)ERR_RETURN);

	status = ask_key("module", mod_key, Def_modulekey, &mod_index, NULL);
	if (status != CONT)
	    return((struct module *)ERR_RETURN);

	if (rawflag)
	{
	    if (!strncmp(Cam_rawstr,  mod_key[mod_index], MAXNAME))
	    {
		status = ask_in_range("crate ", Def_crate, &Def_crate,      1, MAXCRATE - 1, NULL);
		if (status != CONT)
		    return((struct module *)ERR_RETURN);

		status = ask_in_range("slot  ", Def_slot , &Def_slot, 1, MAXSLOT,  NULL);
		if (status != CONT)
		    return((struct module *)ERR_RETURN);

		modptr = &Cam_mod[(Def_crate * MAXSLOT) + Def_slot];

		Def_modulekey    = mod_index;
		return(modptr);
	    }
	}
	if ((modptr = _seekmodule(mod_key[mod_index])) < 0)
	{
	    pmess("key error");
	    return((struct module *)ERR_RETURN);
	}
	Def_modulekey = mod_index;
	return(modptr);
}


	struct module *
_seekmodule(name)
char *name;
{
	int entry;

	for (entry = MAXSLOT; entry < MAXMOD; entry++)
	    if ( Cam_mod[entry].df_busy    &&
		(strncmp(Cam_mod[entry].df_name, name, MAXNAME) == 0) )
		return(&Cam_mod[entry]);
	return((struct module *)-1);
}


_mod_to_key(keyptr, rawflag)
char **keyptr;
{
	/*
	*/

	int     entry, key;

	for (entry = MAXSLOT, key=0; entry < MAXMOD; entry++)
	{
	    if (!Cam_mod[entry].df_busy) continue;
	    keyptr[key++] = (char *)Cam_mod[entry].df_name;
	}
	if (rawflag)
	    keyptr[key++] = Cam_rawstr;
	keyptr[key]   = 0;
	return(SUC_RETURN);
} /* end _mod_to_key */


_isalnumstr(s)
char *s;
{
	int i, len;

	len = strlen(s);

	for (i=0; i<len; i++)
	    if (!isgraph(s[i]))
		return(FALSE);
	return(TRUE);
}


	ACTION
v_show(cmdname)
char *cmdname;
{
	/*
	*/

	ACTION        status;
	int           entry;

#define CAMCRATE
#ifdef  CAMCRATE
	int           crate;

	for (crate=1; crate < MAXCRATE; crate++)
	{
	    int ret;

	    ret = camcrate(crate);
	    printf("\t  crate %d (%s) ", crate,
			(ret == -1) ? " -  " :
			(ret      ) ? "  Up" :
				      "Down" );
	}
	printf("\n");
#endif  CAMCRATE
	printf("\t  --------------------------------------------------------------\n");
	printf("\t  Module \tcrate \tslot \t  user  since\n");
	printf("\t  --------------------------------------------------------------\n");
	for (entry = MAXSLOT; entry < MAXMOD; entry++)
	{
	    if (!Cam_mod[entry].df_busy) continue;
	    printf("%16s \t%d \t%d \t%6.6s\t%s",
		    Cam_mod[entry].df_name,     Cam_mod[entry].df_crate,
		    Cam_mod[entry].df_slot,     Cam_mod[entry].df_user,
		    ctime(&Cam_mod[entry].df_time) );
	}
	return(CONT);
} /* end v_show */


	ACTION
v_install(cmdname)
char *cmdname;
{
	/*
	** Install cam module.
	*/

	ACTION         status;
	struct module *modptr;
	char           name[MAXSTRING];

module_again:
	status = ask_string("modulename", "", name, NULL);
	if (status != CONT)  return(CONT);
	if (!_isalnumstr(name))
	{
	    pmess("Module name should be printable");
	    goto module_again;
	}
	if (strlen(name) >= MAXNAME)
	{
	    pmess("Module name should be shorter");
	    goto module_again;
	}
	if (!strncmp(name, Cam_rawstr, strlen(Cam_rawstr)))
	{
	    pmess("Module name should not start with: %s", Cam_rawstr);
	    goto module_again;
	}

	modptr = _seekmodule(name);
	if (modptr != (struct module *)-1)
	{
	    pmess("Module name already in use");
	    goto module_again;
	}

	status = ask_in_range("crate ", Def_crate, &Def_crate,      1, MAXCRATE - 1, NULL);
	COND_RETURN(status);

	status = ask_in_range("slot  ", Def_slot,  &Def_slot, 1, MAXSLOT,  NULL);
	COND_RETURN(status);

	if (_cam_creat(name, Def_crate, Def_slot) < 0)
	{
	    perror(" error cam_creat");
	    return(CONT);
	}

	{
	    int fd;

	    if ((fd = camopen(name)) < 0)
	    {
		switch(errno)
		{
		case    EXDEV:
		case    ENODEV:
		    pmess("Crate is down (Warning only)");
		    break;
		case    EBUSY:
		    pmess("Slot is busy  (Warning only)");
		    break;
		}
		pmess("Cannot open module %s (Warning only)", name);
/*              return(CONT);   /* Better creat this module linked already */
	    }
	    camclose(fd);
	}

	modptr = &Cam_mod[(Def_crate * MAXSLOT) + Def_slot];
	if (modptr->df_busy)
	{
	    pmess("Module already in use name: %s", modptr->df_name);
	    goto module_again;
	}
	strncpy(modptr->df_name, name,                        MAXNAME);
	strncpy(modptr->df_user, getpwuid(getuid())->pw_name, MAXNAME);
	modptr->df_busy      = TRUE;
	modptr->df_time      = time(0);
	modptr->df_descr     = 0;
	modptr->df_crate     = Def_crate;
	modptr->df_slot      = Def_slot;
	modptr->df_func      = 0;
	modptr->df_addr      = 0;
	return(CONT);
} /* end v_install */


	ACTION
v_remove(cmdname)
char *cmdname;
{
	/*
	*/

	ACTION         status;
	int            camstat;
	int            fd;
	struct module *modptr;
static  KEYLIST        yesno_key   = { "yes", "no",  NULL };
	INDEX          yesno_index;

	if ((modptr = _askfor_module(ASK_MOD)) == (struct module *)ERR_RETURN)
	    return(CONT);

	pmess("This will remove the module (also for other users)");
	status = ask_key("Are you sure", yesno_key, 1, &yesno_index, NULL);
	COND_RETURN(status);

	if (yesno_index)
	    return(CONT);

	modclose(modptr);
	_cam_remove(modptr->df_name);
	modptr->df_busy    = FALSE;
	sprintf(modptr->df_name, "%s%d", CAM_DEV_NAME,
			(modptr->df_crate * MAXSLOT) + modptr->df_slot);
	return(CONT);
} /* end v_remove */



	ACTION
v_start(cmdname)
char *cmdname;
{
	/*
	*/

	ACTION        status;

	status = ask_number("crate   ", Def_crate  , &Def_crate,  NULL);
	COND_RETURN(status);

	if (camrest(Def_crate, 0) < 0)
	{
	    pmess("Can't restart crate %d because:", Def_crate);
	    switch (errno)
	    {
	    case EINVAL:
		pmess("- inproper arguments");
		break;
	    case EFAULT:
		pmess("- Hardware (CES and CC) don't agree about status");
		pmess("- The first camac stroke to the crate gives timeout");
		pmess("- while the CES module tell that the crate is on line");
		pmess("- Try to switch off/on power on camac crate");
		break;
	    case ENETUNREACH:
		pmess("- crate is not reachable");
		pmess("- If the power has been switched off for this crate");
		pmess("- push the Z button (while local)");
		pmess("- and try again     (while online)");
		break;
	    case EALREADY:
		pmess("- crate is already up");
		break;
	    case ENETDOWN:
		pmess("- none of the crates are reachable");
		pmess("- If the power has been switched off for this crate");
		pmess("- push the Z button (while local)");
		pmess("- and try again     (while online)");
		break;
	    case EINTR:
		pmess("- branch demand not enabled");
		break;
	    default:
		perror(" ");
		break;
	    }
	}
	return(CONT);
} /* end v_start */


	ACTION
v_shut(cmdname)
char *cmdname;
{
	/*
	*/

	ACTION        status;

	status = ask_number("crate   ", Def_crate  , &Def_crate,  NULL);
	COND_RETURN(status);

	_shutcrate(Def_crate);

	if (camshut(Def_crate) < 0)
	{
	    pmess("Can't shotdown crate %d because:", Def_crate);
	    switch (errno)
	    {
	    case EALREADY:
		pmess("- crate is already down");
		break;
	    default:
		perror(" ");
		break;
	    }
	}
	return(CONT);
} /* end v_shut */


	ACTION
v_verbose(cmdname)
char *cmdname;
{
	/*
	*/

	ACTION          status;
	static  KEYLIST verb_key   = { "off", "normal", "on",  NULL };
		INDEX   verb_index;

	pmess("Verbosity level");

	status = ask_key("Verbosity", verb_key, 1, &verb_index, NULL);
	COND_RETURN(status);

	switch (verb_index)
	{
	case 0:
	    Cam_verbose = CAM_SILENT;
	    Cam_print   = FALSE;
	    break;
	case 1:
	    Cam_verbose = CAM_SILENT;
	    Cam_print   = TRUE;
	    break;
	case 2:
	    Cam_verbose = CAM_VERBOSE;
	    Cam_print   = TRUE;
	    break;
	}
	return(CONT);
} /* end v_verbose */


	ACTION
v_history(cmdname)
char *cmdname;
{
	ACTION       status;
	unsigned int from;
	unsigned int fromdef, untildef;

	loglam();
	history();
	if (Cam_history == 0)
	    return(CONT);
	if (Cam_history < MAXLOG)
	    from = 0;
	else
	    from = Cam_history - MAXLOG;

	if ((Cam_history - Def_hist_from) <= MAXLOG)
	    fromdef = Def_hist_from;
	else
	    fromdef = Cam_history - 1;

	status = ask_in_range("repeat from ", fromdef,  &Def_hist_from,  from,
					      Cam_history - 1, NULL);
	COND_RETURN(status);

	if ((Def_hist_from <= Def_hist_until)   &&
	    (Cam_history   >= Def_hist_until)   )
	    untildef = Def_hist_until;
	else
	    untildef = Cam_history - 1;

	status = ask_in_range("repeat until", untildef, &Def_hist_until, Def_hist_from,
					      Cam_history - 1, NULL);
	COND_RETURN(status);
	status = ask_in_range("times       ", Def_hist_times, &Def_hist_times,
					      1, 100000, NULL);
	COND_RETURN(status);
	execute(Def_hist_from, Def_hist_until, Def_hist_times);

	return(CONT);
} /* end v_history */


	ACTION
v_camac(cmdname)
char *cmdname;
{
	/*
	*/

	ACTION         status;
	int            camstat;
	struct module *modptr;

	if ((modptr = _askfor_module(ASK_RAW)) == (struct module *)ERR_RETURN)
	    return(CONT);

	status = ask_in_range("a     ", modptr->df_addr, &modptr->df_addr,  0, MAXCAM_A, NULL);
	COND_RETURN(status);

	status = ask_in_range("f     ", modptr->df_func, &modptr->df_func,  0, MAXCAM_F, NULL);
	COND_RETURN(status);

	if  ((modptr->df_func > 15) && (modptr->df_func < 24))
	{
	    status = ask_in_range("d     ", modptr->df_data, &modptr->df_data,  0, 0xffffff, NULL);
	    COND_RETURN(status);
	}

	if (_modopen(modptr->df_name) < (struct module *)0)
	    return(CONT);

	loglam();
	camstat  = camac( modptr->df_descr, modptr->df_addr,
			  modptr->df_func, &modptr->df_data);
	if (errno)
	{
	    perror("wrong camac call");
	    return(CONT);
	}

	if  ((modptr->df_func > 15) && (modptr->df_func < 24))
	    modptr->df_action = CAMCMD_WRITE;
	else
	    modptr->df_action = CAMCMD_READ;
	modptr->df_stat = camstat;
	camlog  (modptr);
	printlog(modptr, Cam_print);

	modclose(modptr);
	return(CONT);
} /* end v_camac */


	ACTION
v_loop(cmdname)
char *cmdname;
{
	/*
	*/

	ACTION         status;
	int            camstat;
	struct module *modptr;

	if ((modptr = _askfor_module(ASK_RAW)) == (struct module *)ERR_RETURN)
	    return(CONT);

	if (_modopen(modptr->df_name) < (struct module *)0)
	    return(CONT);

	for (;;)
	{
	    status = ask_in_range("a     ", modptr->df_addr, &modptr->df_addr,  0, MAXCAM_A, NULL);
	    if (status != CONT)
		break;

	    status = ask_in_range("f     ", modptr->df_func, &modptr->df_func,  0, MAXCAM_F, NULL);
	    if (status != CONT)
		break;

	    if  ((modptr->df_func > 15) && (modptr->df_func < 24))
	    {
		status = ask_in_range("d     ", modptr->df_data, &modptr->df_data,  0, 0xffffff, NULL);
		if (status != CONT)
		    break;
	    }

	    loglam();
	    camstat  = camac( modptr->df_descr, modptr->df_addr,
			      modptr->df_func, &modptr->df_data);
	    if (errno)
	    {
		perror("wrong camac call");
		return(CONT);
	    }

	    if  ((modptr->df_func > 15) && (modptr->df_func < 24))
		modptr->df_action = CAMCMD_WRITE;
	    else
		modptr->df_action = CAMCMD_READ;
	    modptr->df_stat = camstat;
	    camlog(modptr);
	    printlog(modptr, Cam_print);
	}

	modclose(modptr);
	COND_RETURN(status);
} /* end v_loop */


	ACTION
v_response(cmdname)
char *cmdname;
{
	ACTION         status;
	int            sav_print;
	struct module *modptr;

	static  KEYLIST x_key   = { "X", "NOX", "ambivalent",  NULL };
	static  INDEX   x_index;

	static  KEYLIST q_key   = { "Q", "NOQ", "ambivalent",  NULL };
	static  INDEX   q_index;

	if ((modptr = _askfor_module(ASK_RAW)) == (struct module *)ERR_RETURN)
	    return(CONT);

	status = ask_in_range("a     ", modptr->df_addr, &modptr->df_addr,  0, MAXCAM_A, NULL);
	COND_RETURN(status);
	status = ask_in_range("f     ", modptr->df_func, &modptr->df_func,  0, MAXCAM_F, NULL);
	COND_RETURN(status);

	if  ((modptr->df_func > 15) && (modptr->df_func < 24))
	{
	    status = ask_in_range("data  ", modptr->df_data, &modptr->df_data,  0, 0xffffff, NULL);
	    COND_RETURN(status);
	    modptr->df_data_mask = 0;
	    modptr->df_action = CAMCMD_RESP_WRITE;
	}
	else
	{
	    status = ask_in_range("mask  ", modptr->df_data_mask, &modptr->df_data_mask,  0, 0xffffff, NULL);
	    COND_RETURN(status);
	    status = ask_in_range("data  ", modptr->df_resp_data, &modptr->df_resp_data,  0, 0xffffff, NULL);
	    COND_RETURN(status);
	    modptr->df_action = CAMCMD_RESP_READ;
	}

	status = ask_key("X response", x_key, x_index, &x_index, NULL);
	COND_RETURN(status);

	status = ask_key("Q response", q_key, q_index, &q_index, NULL);
	COND_RETURN(status);

	modptr->df_stat_mask = 0;
	modptr->df_resp_stat = 0;

	switch (x_index)
	{
	case 0:  modptr->df_resp_stat |= X;
	case 1:  modptr->df_stat_mask |= X;
	case 2:  break;
	}
	switch (q_index)
	{
	case 0:  modptr->df_resp_stat |= Q;
	case 1:  modptr->df_stat_mask |= Q;
	case 2:  break;
	}

	if (_modopen(modptr->df_name) < (struct module *)0)
	    return(CONT);

	loglam();
	modptr->df_stat = camac( modptr->df_descr, modptr->df_addr,
				 modptr->df_func, &modptr->df_data);
	if (errno)
	{
	    perror("wrong camac call");
	    return(CONT);
	}

	camlog  (modptr);

	sav_print = Cam_print;
	if ((modptr->df_data      & modptr->df_data_mask) !=
	    (modptr->df_resp_data & modptr->df_data_mask))
	{
	    Cam_print = TRUE;
	    printf("Wrong data on next response cycle\n");
	}

	if ((modptr->df_stat      & modptr->df_stat_mask) !=
	    (modptr->df_resp_stat & modptr->df_stat_mask))
	{
	    Cam_print = TRUE;
	    printf("Wrong stat on next response cycle\n");
	}
	printlog(modptr, Cam_print);
	Cam_print = sav_print;

	modclose(modptr);
	return(CONT);
} /* end v_response */


execute(from, until, repeat)
{
		int            sav_print;
		int            camstat;
		int            mod, rep;
		struct module *modptr, *admptr;
	extern  struct module *findlogmod();

	sav_print = Cam_print;
	for (rep = 0; rep < repeat; rep++)
	{
	    for (mod = from; mod <= until; mod++)
	    {
		modptr = findlogmod(mod);
		switch (modptr->df_action)
		{
		case CAMCMD_READ:
		case CAMCMD_WRITE:
		case CAMCMD_RESP_READ:
		case CAMCMD_RESP_WRITE:
		    if ((admptr = _modopen(modptr->df_name)) < (struct module *)0)
			return(CONT);

		    camstat  = camac( admptr->df_descr, modptr->df_addr,
				      modptr->df_func, &modptr->df_data);
		    if (errno)
		    {
			perror("wrong camac call");
			return(CONT);
		    }

		    modptr->df_stat = camstat;

		    switch (modptr->df_action)
		    {
		    case CAMCMD_RESP_READ:
		    case CAMCMD_RESP_WRITE:
			if ((modptr->df_data      & modptr->df_data_mask) !=
			    (modptr->df_resp_data & modptr->df_data_mask))
			{
			    Cam_print = TRUE;
			    printf("Wrong data on next response cycle\n");
			}
			if ((modptr->df_stat      & modptr->df_stat_mask) !=
			    (modptr->df_resp_stat & modptr->df_stat_mask))
			{
			    Cam_print = TRUE;
			    printf("Wrong stat on next response cycle\n");
			}
			break;
		    }

		    printlog(modptr, Cam_print);
		    Cam_print = sav_print;
		    modclose(modptr);
		    break;
		case CAMCMD_LAMENA:
		    if ((admptr = _modopen(modptr->df_name)) < (struct module *)0)
			return(CONT);
		    lam_set(admptr->df_descr);
		    printlog(modptr, Cam_print);
		    signal (SIGCAM, _cam_sig);
		    admptr->df_lam = TRUE;
		    break;
		case CAMCMD_LAMDIS:
		    admptr = _convadm(modptr);
		    if  (admptr->df_descr)
			lam_clr (admptr->df_descr);
		    else
			printf("Descr goon while exec lamdisable\n");

		    modclose(modptr);
		    printlog(modptr, Cam_print);
		    admptr->df_lam = FALSE;
		    break;
		case CAMCMD_LAM:
		    printlog(modptr, Cam_print);
		    while (!Lam_seen);
			Lam_seen = FALSE;
		    break;
		} /* end switch */
	    } /* end for */
	} /* end for */
	return(CONT);
} /* end execute */


	ACTION
v_lam(cmdname)
char *cmdname;
{
	/*
	*/

	ACTION        status;
	struct module *modptr;
static  KEYLIST        lam_key   = { "enable", "disable",  NULL };
	INDEX          lam_index;

	if ((modptr = _askfor_module(ASK_RAW)) == (struct module *)ERR_RETURN)
	    return(CONT);

	if (modptr->df_lam)
	    lam_index = 1;
	else
	    lam_index = 0;

	status = ask_key("lam mode", lam_key, lam_index, &lam_index, NULL);
	COND_RETURN(status);

	loglam();
	if  (lam_index)
	{   /* disable */
	    modptr->df_lam    = FALSE;
	    modptr->df_action = CAMCMD_LAMDIS;

	    if  (modptr->df_descr)
		lam_clr (modptr->df_descr);
	    else
		printf("Descr goon in lamdisable\n");

	    modclose(modptr);
	}
	else
	{   /* enable */
	    if (_modopen(modptr->df_name) < (struct module *)0)
		return(CONT);
	    modptr->df_lam    = TRUE;
	    modptr->df_action = CAMCMD_LAMENA;
	    Cam_lam = *modptr;  /* Structure assignment */
	    lam_set(modptr->df_descr);
	    signal (SIGCAM, _cam_sig);
	}
	camlog(modptr);
	return(CONT);
} /* end v_lam */


_cammod_init()
{
	FILE        *pp;
	int          crate, entry;
	char         filename[MAXSTRING];
	char         linkname[MAXSTRING];
	char         compname[MAXSTRING];
	struct stat  statbuf;

	for (entry = MAXSLOT; entry < MAXMOD; entry++)
	{
	    sprintf(Cam_mod[entry].df_name, "%s%d", CAM_DEV_NAME, entry);
	    strncpy(Cam_mod[entry].df_user, getpwuid(getuid())->pw_name, MAXNAME);

	    Cam_mod[entry].df_busy     = FALSE;
	    Cam_mod[entry].df_time     = 0;
	    Cam_mod[entry].df_descr    = 0;
	    Cam_mod[entry].df_lam      = FALSE;
	    Cam_mod[entry].df_crate    = entry/MAXSLOT;
	    Cam_mod[entry].df_slot     = entry%MAXSLOT;
	}

	strcpy(compname, "ls ");
	strcat(compname, CAM_NODE_AREA);
	bzero (filename, sizeof(filename));

	pp = popen(compname, "r");
	if (pp)
	{
	    while (fscanf(pp, "%s", filename) == 1)
	    {
		strcpy(compname, CAM_NODE_AREA);
		strcat(compname, "/");
		strcat(compname, filename);

		if ( stat(compname, &statbuf))
		    continue;
		if (!(S_ISCHR(statbuf.st_mode)))
		    continue;   /* Not pointing to a character special file */
		if (lstat(compname, &statbuf))
		    continue;
		if (S_ISLNK(statbuf.st_mode))
		{
		    int cnt;
		    cnt = readlink(compname, linkname, sizeof(linkname));
		    if (cnt <= 0)
			printf("Error on readlink ");
		    linkname[cnt] = 0;
		    if (strncmp(linkname, CAM_DEV_NAME, strlen(CAM_DEV_NAME)) == 0)
		    {
			int   num;
			char *chkptr;

			num = strtol( &linkname[strlen(CAM_DEV_NAME)], &chkptr, 10);
			if (chkptr == &linkname[strlen(CAM_DEV_NAME)])
			    continue;
			if (strncmp(Cam_mod[num].df_name, CAM_DEV_NAME, strlen(CAM_DEV_NAME)))
			{   /* There is already a name with this crate and slot */
			    pmess("Module %s discarted, because slot %s already installed",
				   filename, Cam_mod[num].df_name);
			    continue;
			}
			strncpy(Cam_mod[num].df_name, filename, MAXNAME);
			strncpy(Cam_mod[num].df_user, getpwuid(statbuf.st_uid)->pw_name, MAXNAME);
			Cam_mod[num].df_busy     = TRUE;
			Cam_mod[num].df_time     = statbuf.st_mtime;
			Cam_mod[num].df_descr    = 0;
			Cam_mod[num].df_lam      = FALSE;
			Cam_mod[num].df_crate    = num/MAXSLOT;
			Cam_mod[num].df_slot     = num%MAXSLOT;
		    }
		}
	    }
	    pclose(pp);
	}
}

_cam_creat(name, crate, slot)
char *name;
{
	char    compname[MAXSTRING];

	strcpy(compname, CAM_NODE_AREA);
	strcat(compname, "/");
	strcat(compname, name);
	return(mkcamnod(crate, slot, compname));
}


_cam_remove(name)
char *name;
{
	char    compname[MAXSTRING];

	strcpy(compname, CAM_NODE_AREA);
	strcat(compname, "/");
	strcat(compname, name);
	return(rmcamnod(compname));
}


_shutcrate(crate)
{
	int entry;

	if  (crate >= MAXCRATE)  return(CONT);

	for (entry = MAXSLOT; entry < MAXMOD; entry++)
	{
	    if (Cam_mod[entry].df_descr)
	    {
		if (Cam_mod[entry].df_crate == crate)
		{
		    pmess("Shutdown: %s", Cam_mod[entry].df_name);
		    close(Cam_mod[entry].df_descr);
		    Cam_mod[entry].df_descr = 0;
		}
	    }
	}
}

history()
{
	int mod;

	pmess("History of last 16 accesses");
	pmess("----------------------------------------------------------------");
	pmess("Num       name (C, N)   A  F  Sta  Data             Access");
	pmess("----------------------------------------------------------------");
	for (mod = Cam_logindex; mod<MAXLOG; mod++)
	    printlog(&Cam_log[mod], TRUE);
	if  (Cam_logindex == 0) return;
	for (mod = 0; mod<Cam_logindex; mod++)
	    printlog(&Cam_log[mod], TRUE);
}

camlog(modptr)
struct module *modptr;
{
	modptr->df_number = Cam_history++;
	Cam_log[Cam_logindex] = *modptr;      /* Structure assignment */

	if (++Cam_logindex == MAXLOG)
	    Cam_logindex = 0;
	loglam();
}

	struct module *
findlogmod(lookmod)
{
	int mod;

	for (mod = 0; mod < MAXLOG; mod++)
	    if (Cam_log[mod].df_number == lookmod)
		return(&Cam_log[mod]);
}

printlog(modptr, flag)
struct module *modptr;
{
	if (!flag)
	    return;
	if ((modptr->df_crate == 0) || (modptr->df_slot == 0))
	    return;

	printf("%4d - %10.10s (%1d,%2d)",
	    modptr->df_number, modptr->df_name,
	    modptr->df_crate,  modptr->df_slot);

	switch (modptr->df_action)
	{
	case CAMCMD_READ:
	case CAMCMD_WRITE:
	case CAMCMD_RESP_READ:
	case CAMCMD_RESP_WRITE:
	    printf("  %2d %2d  ", modptr->df_addr, modptr->df_func);

	    if (X_RESPONSE(modptr->df_stat))
		 printf("X");
	    else printf("-");

	    if (Q_RESPONSE(modptr->df_stat))
		 printf("Q");
	    else printf("-");

	    if (C_TIMEOUT(modptr->df_stat))
		 printf("T");
	    else printf("-");

	    switch (modptr->df_action)
	    {
	    case CAMCMD_READ:
		printf(" x%6x %8d", modptr->df_data, modptr->df_data);
		printf(" (read  cycle)\n");
		break;
	    case CAMCMD_WRITE:
		printf(" x%6x %8d", modptr->df_data, modptr->df_data);
		printf(" (write cycle)\n");
		break;
	    case CAMCMD_RESP_READ:
		printf(" x%6x response (%6x, %6x)", modptr->df_data,
			 modptr->df_data_mask, modptr->df_resp_data);

		if (modptr->df_stat_mask & X)
		  if (modptr->df_resp_stat & X)
		       printf(" X");
		  else printf(" NOX");
		if (modptr->df_stat_mask & Q)
		  if (modptr->df_resp_stat & Q)
		       printf(" Q");
		  else printf(" NOQ");
		printf("\n");
		break;
	    case CAMCMD_RESP_WRITE:
		printf(" x%6x response (write cycle)   ", modptr->df_data);

		if (modptr->df_stat_mask & X)
		  if (modptr->df_resp_stat & X)
		       printf(" X");
		  else printf(" NOX");
		if (modptr->df_stat_mask & Q)
		  if (modptr->df_resp_stat & Q)
		       printf(" Q");
		  else printf(" NOQ");
		printf("\n");
		break;
	    }
	    break;
	case CAMCMD_LAMENA:
	    printf("              Lam  enabled    (  no  cycle)\n");
	    break;
	case CAMCMD_LAMDIS:
	    printf("              Lam disabled    (  no  cycle)\n");
	    break;
	case CAMCMD_LAM:
	    printf("              Lam seen        (intr  cycle)\n");
	    break;
	} /* end switch */
}


modclose(argmodptr)
struct module *argmodptr;
{
	struct module *admmodptr;

#ifndef STAYOPEN
	/* Be sure to work in real module administration even with log  */
	admmodptr = _convadm(argmodptr);
	if  (( admmodptr->df_descr) && (!admmodptr->df_lam))
	{
	    camclose(admmodptr->df_descr);
	    admmodptr->df_descr = 0;
	    argmodptr->df_descr = 0;
	}
#endif  STAYOPEN
}


	struct module *
_modopen(argmodptr)
struct module *argmodptr;
{
	struct module *admmodptr;

	/* Be sure to work in real module administration even with log  */
	admmodptr = _convadm(argmodptr);

	if (!admmodptr->df_descr)
	{
	    int fd;

	    fd = camopen(admmodptr->df_name);
	    if (fd < 0)
	    {
		switch(errno)
		{
		case    EXDEV:
		case    ENODEV:
		    pmess("Crate is down");
		    break;
		case    EBUSY:
		    pmess("Slot is busy");
		    break;
		}
		pmess("Cannot open module %s", admmodptr->df_name);
		return((struct module *)-1);
	    }
	    admmodptr->df_descr = fd;
	    argmodptr->df_descr = fd;
	}
	return(admmodptr);
}


loglam()
{
	if (Lam_seen)
	{   /* First Lam_seen to FALSE for recursion (used in camlog) */
	    Lam_seen = FALSE;
	    Cam_lam.df_action = CAMCMD_LAM;
	    camlog(&Cam_lam);
	}
}


	struct module *
_convadm(argmodptr)
struct module *argmodptr;
{
	return(&Cam_mod[(argmodptr->df_crate * MAXSLOT) + argmodptr->df_slot]);
}
