#ifndef CMIOCTL_H
#define CMIOCTL_H

#ifndef	__KERNEL__
#include	<sys/ioctl.h>
#include	<errno.h>
extern	int errno;
extern	char Cam_sysdev[];
#endif 

/* check masks */
#define	nMASK	0xf	/* slot within crate */
#define	aMASK	0xf
#define	fMASK	0x1f
#define	N_AMASK	(~aMASK)
#define	N_FMASK	(~fMASK)

typedef	struct	{
	unsigned int    cm_a;
	unsigned int    cm_l;           /* set if cm_a > 15 */
	unsigned int    cm_f;
	unsigned int    cm_data;
	unsigned int    cm_ccsr;
}camcall_t;

typedef	struct	{
	int     cr_status;
	int     cr_crate;
	int     cr_func;
}cracall_t;
#define	CRATE_UP		0
#define	CRATE_OUT		1	/* totally unavailable	*/
#define	CRATE_DOWN		3	/* not (re)started	*/

typedef	struct	{
	int     in_cminor;
	int     in_crate;
	int     in_pid;
}intcall_t;

#ifdef	__KERNEL__
/* to handle verifies & copying easy in linux */
typedef union {
	camcall_t cam;
	cracall_t cra;
	intcall_t lam;
} unicam_t;
#endif

# define	QIGN		0	/* Q-ignored	*/
# define	QREP		1	/* Q-repeat	*/
# define	QSTOP		2	/* Q-stop	*/
# define	NO_QWHILE	3	/* while no Q	*/
# define        MAX_QREPEAT    16
# define	F8	0x8	/* */
# define	F16	0x10	/* */
# define	FDATA	0x18	/* F8 | F16 */

/* functions */
#define CMIOC		'c'
# 	define	CIOCM		_IOWR(CMIOC, 1,camcall_t)
#	define	CIORTI		_IO(  CMIOC, 4)
#       define  CIORES          _IOWR(CMIOC, 5,cracall_t)
#       define  CIOSHUT         _IOWR(CMIOC, 6,cracall_t)
#       define  CIOSETINTR      _IOWR(CMIOC, 7,intcall_t)
#       define  CIOGETINTR      _IOWR(CMIOC, 8,intcall_t)
#       define  CIOGETCRATE     _IOWR(CMIOC,11,cracall_t)
#	define	CIOCYCLE	_IO(  CMIOC,99)

/* parameter hidden in "f" - 16 bits access     */
#define CAM_16  1                       /* single access 16 bits*/
#define CAM_RD  0                       /* read from CAMAC      */
#define CAM_WR  2                       /* write  to CAMAC      */
#define CAM_EX  (CAM_16|CAM_RD)         /* dataless on CAMAC    */
 
#endif	CMIOCTL_H
