#include	<errno.h>
#ifndef	LOCAL_CAMAC_H
#define LOCAL_CAMAC_H
#define reg_t	
#define	DEBUG	/**/
#ifdef DEBUG
#define DBG(k)	printf k ; fflush(stdout)
#else
#define DBG(k)
#endif
/* 
@@@ camac.h - for users of libcam - CAMAC access library
@@@ contains copy of a part of include files of CAMAC driver 
@@@     check it with the changes in CAMAC driver!!!!
*/
#ifndef	CMDEF_H
#define	CMDEF_H
#       define  MAX_CR_CTRL     3
#	define	TOP_SLOT	(31 + (MAX_CR_CTRL << 5))
#       define  SIGCAM          SIGUSR1
#endif	CMDEF_H
#ifndef	CM_H
#define CM_H

/* 
   VME CBD 8210  CAMAC status macro's.
*/

#define	Q		0x8000	/* Q-response received		*/
#define	X		0x4000	/* X-response received		*/
#define	CAM_TO		0x2000	/* time-out signalled		*/
#define	CAM_BD		0x1000	/* BD read transparent status	*/
#define CLR_NO_X        0xc000

#define	Q_RESPONSE(status)	(  (status) & Q)
#define	NO_Q_RESPONSE(status)	(!((status) & Q))
#define	X_RESPONSE(status)	(  (status) & X)
#define	NO_X_RESPONSE(status)	(!((status) & X))
#define	D_RESPONSE(status)	(  (status) & CAM_BD)
#define	NO_D_RESPONSE(status)	(!((status) & CAM_BD))
#define	C_TIMEOUT(status)	(  (status) & CAM_TO)

/*
** DEVICE ORIENTED MACRO's:
**	c crate nr ( that of crate controller)
**	n slot in crate  nr
**	N slot in branch nr
*/

#	define	N_EXT(n,c)	((n) + ((c) << 5))
#	define	N_CR(N)		((N) & 0x1f)
# 	define	CRATE(N)	(((N) >> 5) & 0x3)


#endif	CM_H
#ifndef	CMIOCTL_H
#define CMIOCTL_H
#	define	QIGN		0
#	define	QREP		1
#	define	QSTOP		2
#	define	NO_QWHILE	3
#endif	CMIOCTL_H

#define CAM_NODE_AREA   "/var/cam"
#define CAM_DEV_NAME    "/dev/cm"
#define	CAM_SILENT	0
#define	CAM_VERBOSE	1 
#define	CCSR_ERROR	0x2bad

/* EXTERNALS */
extern	int	Cam_verbose; 	/* default 1 - verbose		*/

extern  int	camopen(   /* dev,prot */);
extern	int	camshut(   /* crate */);
extern	int	camrest(   /* crate,retry */);
extern	int	camac(     /* camfd,a,f,data */);
extern	int	lam_set(   /* camfd */);
extern	int	camrti(    /* camfd */);
extern	int	lam_clr(   /* camfd */);

#endif	LOCAL_CAMAC_H
