/*
** CAM_INTR - CAMRTI,LAM_SET,LAM_CLR,LAM_GET
*/
# include	<sys/types.h>
# include	<sys/ioctl.h>
# include	<stdio.h>
# include       "camioctl.h"
# include	"camac.h"

camrti(int fd)
{
	return(ioctl(fd, CIORTI,(caddr_t)0) );
}


lam_set(int fd)
{
		intcall_t     ua;
	reg_t   intcall_t     *uap = {&ua};

	uap->in_pid = getpid();
	if(ioctl(fd,CIOSETINTR,uap) < 0)
	{
	    if(Cam_verbose != CAM_VERBOSE)
		return(-1);
	    perror("lam_set");
	}
	return(1);
}


lam_clr(int fd)
{
		intcall_t     ua;
	reg_t   intcall_t     *uap = {&ua};

	uap->in_pid = 0;
	if(ioctl(fd,CIOSETINTR,uap) < 0)
	{
	    if(Cam_verbose != CAM_VERBOSE)
		return(-1);
	    perror("lam_clr");
	}
	return(1);
}


lam_get(int fd)
{
		intcall_t     ua;
	reg_t   intcall_t     *uap = {&ua};

	uap->in_pid = getpid();
	if (Cam_verbose == CAM_VERBOSE)
	    fprintf(stderr,"process: %d ",uap->in_pid);
	if (ioctl(fd,CIOGETINTR,uap) < 0)
	{
	    if(Cam_verbose != CAM_VERBOSE)
		return(-1);
	    perror("lam_get");
	    return(-1);
	}
	if (Cam_verbose != CAM_VERBOSE)
	    return(1);
	fprintf(stderr,"crate %d slot %2d - %s\n"
		,uap->in_cminor & 0x1f
		,uap->in_crate
		,(uap->in_pid ? "set" : "cleared")
		);
	return(1);
}
