/*
** CAM_IO - CAMAC
*/

# include	<sys/types.h>
# include	<sys/ioctl.h>
# include	<stdio.h>
# include       "camioctl.h"
# include	"camac.h"

camac(unsigned int fd,unsigned int  a,unsigned int  f, int *data)
{
	camcall_t	ua;
	camcall_t      *uap = {&ua};
	register int    csr;

	/* Here we hide access 16 to datalines */
	uap->cm_l = 0;
	uap->cm_a = a;
	if(a > 15)
	{
	    uap->cm_a = a & 0xF;
	    uap->cm_l = 1;
	}
	uap->cm_f = f;
	if( f > 15 && f < 24)
	{ /* write        */
	    uap->cm_data = *((int *)data);
	}
	errno = 0;
 	if (ioctl(fd, CIOCM, &ua) == -1)
	{
	    if(Cam_verbose != CAM_SILENT)
		perror("camac");
	    return(CCSR_ERROR);
	}
	csr = uap->cm_ccsr;
	if (f < 16 )
	{  /* read */
	    *data = uap->cm_data;
	}
	return(csr);
} /* end CAMAC */

#ifdef  NOT_DEFINED
camamc(unsigned int fd, unsigned int a,unsigned int  f, int q_mode, caddr_t buf,unsigned int  len)
{
	amccall_t	ua;
	amccall_t	*uap = {&ua};
	register int	count;

	uap->am_a	= a;
	uap->am_f	= f;
	uap->am_q	= q_mode;
	uap->am_busy	= 1; 
	switch(f & FDATA) {
	case	0:
		uap->am_rw	= B_READ;
		break;
	case	F16:
		uap->am_rw	= B_WRITE;
		break;
		
	default:
		if(Cam_verbose != CAM_VERBOSE)
			return(-1);
		errno = EINVAL;
		perror("camamc:  parameters setting");
		return(0);
	} /* end switch (f)	*/
	if(ioctl(fd,CIOSETAMC,uap) < 0)
	{
		if(Cam_verbose != CAM_VERBOSE)
			return(0);
		perror("camamc: ioctl ");
		return(CCSR_ERROR);
	}
	switch(f & FDATA) {
	case	0:
		count = read(fd,buf,len);
		break;
	case	F16:
		count = write(fd,buf,len);
		break;
	} /* end switch (f)	*/
	if(count == len)
		return(len);
	if(Cam_verbose != CAM_VERBOSE)
		return(count);
	perror("camamc:  data access length fault");
	return(count);
} /* end CAMAMC */

camrlse(unsigned int fd)
{
	amccall_t	ua;
	amccall_t	*uap = {&ua};

	uap->am_busy	= 0;
	if(ioctl(fd,CIOSETAMC,uap) < 0)
	{
		if(Cam_verbose != CAM_VERBOSE)
			return(0);
		perror("camrlse");
		return(0);
	}
	return(1);
} /* end CAMRLSE*/

camseek(unsigned int fd,unsigned int  a,unsigned int  f,int  q_mode)
{
	amccall_t	ua;
	amccall_t	*uap = {&ua};

	uap->am_a	= a;
	uap->am_f	= f;
	uap->am_q	= q_mode;
	uap->am_busy	= 1;
	switch(f & FDATA) {
	case	0:
		uap->am_rw	= B_READ;
		break;
	case	F16:
		uap->am_rw	= B_WRITE;
		break;
		
	default:
		if(Cam_verbose != CAM_VERBOSE)
			return(-1);
		errno = EINVAL;
		perror("camseek:  parameters setting");
		return(0);
	} /* end switch (f)	*/
	if(ioctl(fd,CIOSETAMC,uap) < 0)
	{
		if(Cam_verbose != CAM_VERBOSE)
			return(0);
		perror("camseek");
		return(0);
	}
	return(1);
} /* end CAMSEEK */

camget(int fd)
{
	amccall_t	ua;
	amccall_t	*uap = {&ua};
	
	if(ioctl(fd,CIOGETAMC,uap) < 0)
	{
		if(Cam_verbose != CAM_VERBOSE)
			return(0);
		perror("camget");
		return(0);
	}
	printf("naf %x a %x f %x q %x rw %x busy %x\n"
		,uap->am_naf
		,uap->am_a
		,uap->am_f
		,uap->am_q
		,uap->am_rw
		,uap->am_busy
		);
}
#endif  NOT_DEFINED
