#include <stdio.h>
#include "cmd.h"
#include "def.h"

/*
 *	ASK_FLOAT --------------------------------------------------------------
 *	Asks the given question and returns the floating number
 *	the user answers.
 *	Uses "ask_ffloat" to do the work.
 *	Global commands are recognized 
 *	and executed, after which the question is repeated, etc.
 *	Returns CONT if an answer was given, or STOP, HOME or PREV if
 *	the global commands "quit", "restart" or "exit" were typed.
 */
	ACTION
ask_float(question, dfault, number, helpfile)
char	*question, *helpfile;
float	dfault, *number;
{
	return (ask_ffloat(question,"%.3f",dfault,number,helpfile));
}

/*
 *	ASK_FFLOAT -------------------------------------------------------------
 *	Asks the given question and returns the floating number
 *	the user answers.
 *	The default is printed according a given format.
 *	Uses "ask_answer" to do the actual writing and reading.
 *	Global commands are recognized 
 *	and executed, after which the question is repeated, etc.
 *	Returns CONT if an answer was given, or STOP, HOME or PREV if
 *	the global commands "quit", "restart" or "exit" were typed.
 *
 */

	ACTION
ask_ffloat(question, format, dfault, number, helpfile)
char	*question, *format, *helpfile;
float	dfault, *number;
{
		ACTION	status;
		CMD *	global;
		char	df_string[11];
		char	answer[MAXLEN];
		int     ret;

	extern  int     Help_type;
	extern  char *  Help_file;
	extern  char *  Help_text;
	extern	ACTION	ask_answer();

	sprintf(df_string,
		(dfault > NO_FLOAT-0.1 && dfault < NO_FLOAT+0.1 ? "" : format),
		dfault);

	while (1)
	{
	    if (ask_answer(question, df_string, answer) == STOP)
		return (STOP);

	    ret = cmd_match(answer, NULL, NULL, &global);
	    switch(ret)
	    {
	    case MATCH_AMB:
		break;
	    case MATCH_NOT:
		if (sscanf(answer,"%f",number) != 1)
		{
		    error("You were expected to answer a floating point number.");
		    break;
		}
		return (CONT);
	    case MATCH_GLO:
		Help_type = H_NUMBER;
		Help_file = helpfile;
		Help_text = "a floating point number";
		status = (*global->function)(global->name);
		if (status != CONT)
		    return (status);
		break;
	    } /* end switch (ret ... */
	} /* end of while */
}
