#include <stdio.h>
#include "cmd.h"
#include "def.h"

/*
 *	ASK_KEY ----------------------------------------------------------------
 *	Asks the given question and returns an index into the supplied
 *	list of keys, pointing to the key with the name that the user
 *	answers. Uses "ask_answer" to do the actual writing and reading.
 *	Global commands are recognized 
 *	and executed, after which the question is repeated, etc.
 *	Returns CONT if an answer was given, or STOP, HOME or PREV if
 *	the global commands "quit", "restart" or "exit" were typed.
*/


	ACTION
ask_key(question, keys, dfault, key, helpfile)
char    *question;
KEYLIST  keys;
INDEX    dfault;
INDEX   *key;
char    *helpfile;
{
		 ACTION  status;
		 CMD *   global;
		 char    qx [40*MAXLEN];
		 char    answer[MAXLEN];
		 int     size = 0;
	register INDEX   index;
	extern   int     Help_type;     /* Type of expected input           */
	extern   char   *Help_file;     /* File with extended info          */
	extern   char   *Help_text;     /* Description of expected info     */
	extern   ACTION  ask_answer();

	strcpy(qx,question); strcat(qx,":"); strcat(qx,Cquestion);
	for (index = 0; keys[index] != NULL; ++index)
	{
	    strcat(qx,keys[index]);
	    if (keys[index+1] == NULL)
		continue;
	    else
	    if (keys[index+2] == NULL)
		 strcat(qx," or ");
	    else strcat(qx,", ");

	    size += strlen(keys[index])+2;
	    if (size > 59)
	    {
		strcat(qx,Cquestion);
		size = 0;
	    }
	}

	while (1)
	{
	    if (ask_answer(qx, dfault != NO_KEY ? keys[dfault] : NULL,answer) == STOP)
		return (STOP);
	    lower_case(answer);

	    index = cmd_match(answer, NULL, keys, &global);
	    switch(index)
	    {
	    case MATCH_NOT:
		error("Answer %s is not recognized.", answer);
	    case MATCH_AMB:
		break;
	    case MATCH_GLO:
		Help_type = H_KEY;
		Help_file = helpfile;
		Help_text = "one of the given keys";
		status = (*global->function)(global->name);
		if (status != CONT)
		    return (status);
		break;
	    default:
		*key = index;
		return (CONT);
	    } /* end switch (index ... */
	}
}
