#include <stdio.h>
#include "cmd.h"
#include "def.h"

/*
 *      ASK_LINE -------------------------------------------------------------
 *      Asks the given question and returns the next line or the remainder of
 *      the line to the user answers.
 *      Global commands are recognized and executed, after which the
 *      question is repeated, etc.
 *	Returns CONT if an answer was given, or STOP, HOME or PREV if
 *	the global commands "quit", "restart" or "exit" were typed.
 */

	ACTION
ask_line(question,  dfault,  string,  helpfile)
char    *question, *dfault, *string, *helpfile;
{
		ACTION	status;
		CMD *	global;
		char	answer[MAXLEN];
		int     index, ret;
	extern	char	Ch;
	extern  int     Help_type;      /* Type of expected input           */
	extern  char *  Help_file;      /* File with extended para info     */
	extern  char *  Help_text;      /* Description of expected para     */

	for (;;)
	{
	    if (Ch == '\n'|| Ch == '\r')
	    {
		printf("%s%s", Bquestion, question);
		if (dfault != NULL && *dfault != '\0')
		    printf("%s%s%s", Bdefault, dfault, Edefault);
		printf("%s", Equestion);
	    }

	    index = 0;
	    while ((Ch = in_char()) != 0)
	    {
		if (Ch == '\n')
		{
		    answer[index] = '\0';
		    break;
		}
		answer[index++] = Ch;
	    }

	    if (answer[0] == '\0')
	    {
		if (dfault == NULL || *dfault == '\0')
		{
		    error("* There is no default answer to this question.\n");
		    continue;
		}
		else
		    strcpy(answer, dfault);
	    }

	    ret = cmd_match(answer, (CMD *)NULL, (KEY *)NULL, &global);
	    switch(ret)
	    {
	    case MATCH_AMB:
		break;
	    case MATCH_NOT:
		strcpy(string,(*answer == '"' ? answer+1 : answer));
		return (CONT);
	    case MATCH_GLO:
		Help_type = H_STRING;
		Help_file = helpfile;
		Help_text = "an alphanumeric value";
		status = (*global->function)(global->name);
		if (status != CONT)
		    return (status);
		break;
	    } /* end switch (ret .. */
	}
}

