/* $Log: ask_number.c,v $
 * Revision 1.1  1992/03/16  12:49:20  ruud
 * Initial revision
 *
 * Revision 1.9  1992/03/11  11:18:32  ruud
 * Version before match/static operation
 *
*/

#include	<stdio.h>
#include	"cmd.h"
#include	"def.h"

/*
 *	ASK_NUMBER -------------------------------------------------------------
 *	Asks the given question and returns the integer number the user answers.
 *	Uses "ask_answer" to do the actual writing and reading.
 *	Global commands are recognized and executed, after which the question
 *	is repeated, etc.
 *	Returns CONT if an answer was given, or STOP, HOME or PREV if
 *	the global commands "quit", "restart" or "exit" were typed.
*/

	ACTION
ask_number(question, dfault, number, helpfile)
char	*question, *helpfile;
int	dfault, *number;
{
		ACTION	status;
		CMD *	global;
		char	df_string[11];
		char	answer[MAXLEN];
		int     ret;
	extern  int     Help_type;      /* Type of expected input           */
	extern  char *  Help_file;      /* File with extended info          */
	extern  char *  Help_text;      /* Description of expected info     */
	extern	ACTION	ask_answer();

	while (1)
	{
	    if (dfault == NO_NUMBER)
		strcpy(df_string,"");
	    else
	    {
		switch(Outm_index)
		{
		default:
		    ill_outmode();
		case KEY_DECIMAL:
		    sprintf(df_string,"%d",dfault);
		    break;
		case KEY_OCTAL:
		    sprintf(df_string,"0%o",dfault);
		    break;
		case KEY_HEXA:
		    sprintf(df_string,"x%x",dfault);
		    break;
		}
	    }

	    if (ask_answer(question,df_string,answer) == STOP)
		return (STOP);

	    ret = cmd_match(answer, NULL, NULL, &global);
	    switch(ret)
	    {
	    case MATCH_AMB:
		break;
	    case MATCH_NOT:
		if (ask_any(number, answer) < 0)
		    break;
		return (CONT);
	    case MATCH_GLO:
		Help_type = H_NUMBER;
		Help_file = helpfile;
		Help_text = "an integer number";
		status = (*global->function)(global->name);
		if (status != CONT)
		    return (status);
		break;
	    } /* end switch (ret ... */
	}
}


#ifndef	FALSE
#define	FALSE	0
#endif

#ifndef	TRUE
#define	TRUE	1
#endif

char *
pr_any(value)
unsigned value;
{
	/*
	** Be aware of static data! (no recursion)
	*/

	static	char	numstr[10];

	switch(Outm_index)
	{
	    default:
		ill_outmode();
	    case KEY_DECIMAL:
		sprintf(numstr,"%d",value);
		break;
	    case KEY_OCTAL:
		sprintf(numstr,"0%o",value);
		break;
	    case KEY_HEXA:
		sprintf(numstr,"x%x",value);
		break;
	}
	return(numstr);
}

/*
 *	ASK_ANY ------
 *	Read octal decimal or hexadecimal value into *numptr
 *	or print format-error.
 *	Arg: numptr  pointer to return value.
 *	No provisions against overflow !!
 */
ask_any(numptr,answer)
int *numptr;
char *answer;
{
	register int		i;
	register int		alloke;
		 unsigned	value;

	alloke = TRUE;	/* assumption */
	value = 0;

	switch(answer[0])
	{
	    case '0':
		/* Octal input starts with a zero */
		for(i=1; answer[i]; ++i)
		{
		    if (answer[i] < '0' || answer[i] > '7')
		    {
			alloke = FALSE;
			break;
		    }
		    value <<= 3;
		    value += (answer[i] - '0');
		}
		if (alloke == FALSE)
		    error("You were expected to give a valid octal.");
		break;
	    case 'x':
	    case 'X':
		/* Hexadecimal input starts with an x or X */
		for(i=1; answer[i]; ++i)
		{
		    value <<= 4;
		    if (answer[i] >= 'a' && answer[i] <= 'f')
			    value += (answer[i] - 'a' + 10);
		    else if (answer[i] >= 'A' && answer[i] <= 'F')
			    value += (answer[i] - 'A' + 10);
		    else if (answer[i] >= '0' && answer[i] <= '9')
			    value += (answer[i] - '0');
		    else
		    {
			alloke = FALSE;
			break;
		    }
		}
		if (alloke == FALSE)
		    error("You were expected to give a valid hexadecimal.");
		break;
	    default:
		if (sscanf(answer,"%d",&value) != 1)
		{
		    alloke = FALSE;
		    error("You were expected to give a valid integer.");
		}
		break;
	}
	if (alloke == TRUE)
	{
	    *numptr = value;
	    return(0);
	}
	else
	    return(-1);
}

/*
 *	ILL_OUTMODE ------
 *	Output mode has an illegal value. Print it and change back to decimal.
 */
ill_outmode()
{
	printf("unknown output mode %d, switched to decimal\n", Outm_index);
	Outm_index = KEY_DECIMAL;
}
