#include <stdio.h>
#include "cmd.h"
#include "def.h"

/*
 *	ASK_STRING -------------------------------------------------------------
 *	Asks the given question and returns the string the user answers.
 *	Uses "ask_answer" to do the actual writing and reading.
 *	If the string starts with a quote, it is stripped off.
 *	Global commands are recognized (before the stripping of quotes)
 *	and executed, after which the question is repeated, etc.
 *	Returns CONT if an answer was given, or STOP, HOME or PREV if
 *	the global commands "quit", "restart" or "exit" were typed.
 */
ACTION
ask_string(question,dfault,string,helpfile)
char	*question, *dfault, *string, *helpfile;
{
		ACTION	status;
		CMD *	global;
		char	answer[MAXLEN];
		int     ret;

	extern  int     Help_type;      /* Type of expected input           */
	extern  char *  Help_file;      /* File with extended para info     */
	extern  char *  Help_text;      /* Description of expected para     */
	extern	ACTION	ask_answer();

	while (1)
	{
	    if (ask_answer(question,dfault,answer) == STOP)
		return (STOP);

	    ret = cmd_match(answer, NULL, NULL, &global);
	    switch(ret)
	    {
	    case MATCH_AMB:
		break;
	    case MATCH_NOT:
		strcpy(string,(*answer == '"' ? answer+1 : answer));
		return (CONT);
	    case MATCH_GLO:
		Help_type = H_STRING;
		Help_file = helpfile;
		Help_text = "an alphanumeric value";
		status = (*global->function)(global->name);
		if (status != CONT)
		    return (status);
		break;
	    } /* end switch (ret ... */
	} /* end while .. */
}
