/*
 *	CMD.H ------
 *	definitions for command decoder package "cmd"
 */

#ifndef NULL
#define NULL		0
#endif
#ifndef EOF
#define EOF		-1
#endif
#define NO_FLOAT	946218.18
#define NO_KEY		-1
#define NO_NUMBER	-999
#define NO_STRING	NULL
#define MAXLEN		100
#define H_COMMAND	1
#define H_NUMBER	2
#define H_STRING	3
#define H_KEY		4
#define M_FULL		0
#define M_PARTIAL	1
#define INT_DFL		(int (*)()) 0
#define INT_OFF		(int (*)()) 1
#define INT_ON		cmd_interrupt

/*
 *	Type Definitions:
 */
typedef enum {CONT,PREV,HOME,STOP} ACTION;

typedef struct {
		char *	name;
		ACTION	(*function)();
	} CMD;

typedef char *	KEY;

typedef CMD CMDLIST[];
typedef KEY KEYLIST[];
typedef int INDEX;

/*
 *	Globals for outputmode and pr_any facilities.
 */
#define	KEY_DECIMAL	0
#define	KEY_OCTAL	1
#define	KEY_HEXA	2

/*
 *	Macro's:
 */
#define COND_RETURN(s)	if (s != CONT) return (s == PREV ? CONT : s)

/*
 *	Functions:
 */
extern	ACTION	command();	/* (cmdlist) */
extern	ACTION	ask_string();	/* (question,dfault,string,helpfile) */
extern	ACTION	ask_number();	/* (question,dfault,number,helpfile) */
extern	ACTION	ask_float();	/* (question,dfault,number,helpfile) */
extern	ACTION	ask_ffloat();	/* (question,format,dfault,number,helpfile) */
extern	ACTION	ask_key();	/* (question,keys,dfault,key,helpfile) */

extern	int	pmess();
extern	int	bmess();
extern	int	cmess();
extern	int	emess();
extern	int	fmess();

extern	int	error();
extern	int	cmd_fatal();

extern	int	set_help();
extern	int	set_input();
extern	int	set_home();
extern	int	set_raw();
extern	int	set_cooked();
extern	int (*	set_interrupt())();
extern	int	cmd_interrupt();

extern	char *	in_item();
extern	char	in_char();
extern	char *	in_line();
extern	int	back_char();

/*
 *	Layout Strings:
 */
extern	char *	Bprompt;	/* beginning of prompt */
extern	char *	Eprompt;	/* end of prompt */
extern	char *	Bquestion;	/* beginning of question */
extern	char *	Cquestion;	/* continuation of question */
extern	char *	Equestion;	/* end of question */
extern	char *	Bdefault;	/* beginning of default */
extern	char *	Edefault;	/* end of default */
extern	char *	Bmessage;	/* beginning of message */
extern	char *	Cmessage;	/* continuation of message */
extern	char *	Emessage;	/* end of message */
extern	char *	Berror;		/* beginning of error message */
extern	char *	Cerror;		/* continuation of error message */
extern	char *	Eerror;		/* end of error message */

/*
 *	Globals, settable by the programmer:
 */
extern	int	map_to_lower;	/* if not 0: map chars in keys and commands
				   to lowercase */
extern	INDEX	Outm_index;	/* output mode, default KEY_DECIMAL */
