#include <stdio.h>
#include "cmd.h"
#include "def.h"

FILE *	HelpStream;

/*
 *	CMD_QMARK --------------------------------------------------------------
 *	Execute global command: ?
 */
ACTION
cmd_qmark()
{
	extern	int	Help_type;
	extern	char *	Help_text;
	extern	CMD *	Help_list;

	if (Help_type == H_COMMAND)
		print_cmds(Help_list,M_PARTIAL);
	else
		helppar(Help_text,NULL);
	pmess("Type \"help\" for more detailed information.");
	return (CONT);
}

/*
 *	CMD_HELP ---------------------------------------------------------------
 *	Execute global command: help
 */
ACTION
cmd_help()
{
	extern	int	Help_type;
	extern	CMD *	Help_list;
	extern	char *	Help_text;
	extern	char *	Help_file;

	if (Help_type == H_COMMAND)
		helpcmd(Help_list);
	else
		helppar(Help_text,Help_file);
	return (CONT);
}

helpcmd(cmdlist)
CMDLIST	cmdlist;
{
	extern	CMDLIST	Global_cmds;

	pmess("You are executing the %s command.",cmdlist[0].name);
	print_cmds(cmdlist,M_FULL);
	print_cmds(Global_cmds,M_FULL);
	return;
}

/*
 *	HELPPAR ----------------------------------------------------------------
 *	Inform user about type of expected parameter.
 *	If a help file is available, copy the information from that file.
 *	The output starts with Bmessage, and ends with Emessage.
 *	The help file contains the bare message lines, without layout strings.
 */
helppar(type,h_file)
char	*type, *h_file;
{
	extern	FILE *	HelpStream;
		char	file_name[MAXPATH];
	extern	CMDLIST	Global_cmds;
	extern	char	HelpDir[];
	extern	int	helpclose();
		int (*	save_interrupt)();

	bmess("You are supposed to answer %s,",type);
	emess("or to give a global command.");
	if (h_file == NULL)
		return;
	sprintf(file_name,"%s/%s",HelpDir,h_file);
	save_interrupt = set_interrupt(INT_OFF);
	if ((HelpStream = fopen(file_name,"r")) != NULL) {
		set_interrupt(helpclose);
		bmess(NULL);
		fmess(HelpStream);
		set_interrupt(INT_OFF);
		fclose(HelpStream);
		emess(NULL);
	}
	set_interrupt(save_interrupt);
	print_cmds(Global_cmds,M_FULL);
}

/*
 *	PRINT_CMDS -------------------------------------------------------------
 *	Display all commands available in a given cmdlist.
 *	Entry 0 of the list contains the name of the commandset.
 *	Lists end with a NULL name. If mode is M_FULL and a file
 *	with the name of the cmdset (entry 0) is found in directory HelpDir,
 *	this file (containing the cmds with a short explanation) is printed.
 *	Otherwise, only the commands as found in the list are printed.
 *	The output begins with Bmessage, and ends with Emessage.
 *	The help file contains the bare message lines, without layout strings.
 */
print_cmds(cmdlist,mode)
CMDLIST	cmdlist;
int	mode;
{
		int	i;
	extern	FILE *	HelpStream;
		char	file_name[MAXPATH];
	extern	CMDLIST	Global_cmds;
	extern	char	HelpDir[];
	extern	int	helpclose();
		int (*	save_interrupt)();

	sprintf(file_name,"%s/%s",HelpDir,cmdlist[0].name);
	bmess("The following %scommands are available:",
		cmdlist == Global_cmds ? "global " : "sub");
	save_interrupt = set_interrupt(INT_OFF);
	if (mode == M_FULL && (HelpStream = fopen(file_name,"r")) != NULL) {
		set_interrupt(helpclose);
		cmess(NULL);
		fmess(HelpStream);
		set_interrupt(INT_OFF);
		fclose(HelpStream);
		set_interrupt(save_interrupt);
	}
	else {
		set_interrupt(save_interrupt);
		for (i = 1; cmdlist[i].name != NULL; ++i)
		{	if ((i-1)/4*4 == i-1)
				cmess("   ");
			printf("%-17s",cmdlist[i].name);
		}
	}
	emess(NULL);
	return;
}

/*
 *	HELPCLOSE --------------------------------------------------------------
 *	Entered after interrupt when HelpStream is open.
 *	Closes the stream and jumps to cmd_interrupt, which never returns.
 */
helpclose()
{
	extern	FILE *	HelpStream;

	set_interrupt(INT_OFF);
	fclose(HelpStream);
	cmd_interrupt();
	/* NOT REACHED */
}
