#include <stdio.h>
#include "cmd.h"
#include "def.h"

/*
 *	PMESS ------------------------------------------------------------------
 *	Print a message, preceeded by Bmessage, and followed by Emessage.
 *	Usage is like printf.
 *	If first parameter is NULL, only the layout strings are printed.
 */

/* VARARGS 1 */

pmess(m,p0,p1,p2,p3,p4,p5,p6,p7,p8,p9)
char *	m;
char *	p0, *p1, *p2, *p3, *p4, *p5, *p6, *p7, *p8, *p9;
{
	printf("%s",Bmessage);
	if (m != NULL)
		printf(m,p0,p1,p2,p3,p4,p5,p6,p7,p8,p9);
	printf("%s",Emessage);
	fflush(stdout);
	return;
}

/*
 *	BMESS ------------------------------------------------------------------
 *	Print the beginning of a message, preceeded by Bmessage.
 *	Usage is like printf.
 *	If first parameter is NULL, only the layout string Bmessage is printed.
 */

/* VARARGS 1 */

bmess(m,p0,p1,p2,p3,p4,p5,p6,p7,p8,p9)
char *	m;
char *	p0, *p1, *p2, *p3, *p4, *p5, *p6, *p7, *p8, *p9;
{
	printf("%s",Bmessage);
	if (m != NULL)
		printf(m,p0,p1,p2,p3,p4,p5,p6,p7,p8,p9);
	fflush(stdout);
	return;
}

/*
 *	CMESS ------------------------------------------------------------------
 *	Print the continuation of a message, preceeded by Cmessage.
 *	Usage is like printf.
 *	If first parameter is NULL, only the layout string Cmessage is printed.
 */

/* VARARGS 1 */

cmess(m,p0,p1,p2,p3,p4,p5,p6,p7,p8,p9)
char *	m;
char *	p0, *p1, *p2, *p3, *p4, *p5, *p6, *p7, *p8, *p9;
{
	printf("%s",Cmessage);
	if (m != NULL)
		printf(m,p0,p1,p2,p3,p4,p5,p6,p7,p8,p9);
	fflush(stdout);
	return;
}

/*
 *	EMESS ------------------------------------------------------------------
 *	Print the end of a message, preceeded by Cmessage,
 *	and followed by Emessage.
 *	Usage is like printf.
 *	If first parameter is NULL, only the layout string Emessage is printed.
 */

/* VARARGS 1 */

emess(m,p0,p1,p2,p3,p4,p5,p6,p7,p8,p9)
char *	m;
char *	p0, *p1, *p2, *p3, *p4, *p5, *p6, *p7, *p8, *p9;
{
	if (m != NULL) {
		printf("%s",Cmessage);
		printf(m,p0,p1,p2,p3,p4,p5,p6,p7,p8,p9);
	}
	printf("%s",Emessage);
	fflush(stdout);
	return;
}

/*
 *	FMESS ------------------------------------------------------------------
 *	Copy a message from a file to stdout. Each newline character will
 *	be replaced by the Cmessage string, except the last one, which
 *	will be deleted completely. The file is not opened, nor closed.
 */
fmess(helpstream)
FILE *	helpstream;
{
	register char	c;
	register BOOL	eol = FALSE;

	while ((c = fgetc(helpstream)) != EOF) {
		if (eol) {
			printf("%s",Cmessage);
			eol = FALSE;
		}
		if (c == '\n')
			eol = TRUE;
		else
			putchar(c);
	}
	fflush(stdout);
	return;
}
