#include <stdio.h>
#include <bsd/sgtty.h>
#include <sys/ioctl.h>
#include "cmd.h"
#include "def.h"

static struct sgttyb *Tty = NULL;

/*
 *	SET_RAW -----------------------------------------------------------------
 *	Set raw input mode (i.e. in_char returns character as soon as it is
 *	typed, and character is not echoed to terminal).
 *	For level 0 input (standard input), set tty if changed.
 *	Set 'Raw' flag for getline and in_char.
 */
set_raw()
{
	extern	BOOL	Raw;
	extern	struct
		sgttyb *Tty;

	if (Tty == NULL) {
		Tty = (struct sgttyb *) malloc(sizeof(struct sgttyb));
		gtty(fileno(stdin),Tty);
	}
	if ((Tty->sg_flags&CBREAK) != CBREAK || (Tty->sg_flags&ECHO) == ECHO) {
		Tty->sg_flags = (Tty->sg_flags|CBREAK)&~ECHO;
		stty(fileno(stdin),Tty);
	}
	Raw = TRUE;
	return;
}

/*
 *	SET_COOKED --------------------------------------------------------------
 *	Reset raw input mode (i.e. in_char returns characters only after newline is
 *	typed, and character is echoed to terminal).
 *	For level 0 input (standard input), set tty if changed.
 *	Reset 'Raw' flag for getline and in_char.
 */
set_cooked()
{
	extern	BOOL	Raw;
	extern	struct
		sgttyb *Tty;

	if (Tty == NULL) {
		Tty = (struct sgttyb *) malloc(sizeof(struct sgttyb));
		gtty(fileno(stdin),Tty);
	}
	if ((Tty->sg_flags&CBREAK) == CBREAK || (Tty->sg_flags&ECHO) != ECHO) {
		Tty->sg_flags = (Tty->sg_flags&~CBREAK)|ECHO;
		stty(fileno(stdin),Tty);
	}
	Raw = FALSE;
	return;
}
