/* Torens van Hanoi */


#include <stdio.h>
#ifdef	TOW_32
#define bc  4
#define start	0x800000
#define	dev "/dev/vme24d32"
#else
#define bc 2
#define start	0x524000
#define	dev "/dev/vme24d16"
#endif
int costam[0x20000];


int towers(int n, int i, int j, int fd, int peg_len)
{
	int k;
	static int moves;

	if (n == 1)
	{
		moves++;
		/* printf("Move a disk from peg %d to peg %d\n", i, j);/**/
		lseek(fd,start + i * peg_len * bc, SEEK_SET);
		read(fd, &costam, peg_len * bc);
		lseek(fd,start + j * peg_len * bc, SEEK_SET);
		write(fd, &costam, peg_len * bc);
	}
	else
	{
		k = 6  - i - j;
		towers(n-1, i, k, fd,peg_len);
		towers(1, i, j, fd,peg_len);
		towers(n-1, k, j, fd,peg_len);
	}

	return moves;
}

main(int _argc, char *_argv[])
{
	int	pegs,moves;
	int	fd,peg_len;
	extern int errno;	

	if(_argc < 2)
	{
		printf("Usage: hanoi%d  pegs  {peg_len}\n",bc);
		exit(1);
	}
	
	fd = open(dev, 2);
	if (fd<0 )
	{
		perror("open failed");
		exit(1);
	}
	pegs = atoi(_argv[1]);
	if(_argc > 2)
		peg_len = atoi(_argv[2]);
	else
		peg_len = 1;

	printf("Towers of Hanoi on %s:  %d pegs of %d \n",dev,pegs,peg_len);

	moves = towers(pegs, 1, 3, fd, peg_len);
	close(fd);
	printf("%d moves each %d bytes on /dev/vme24d16\n", moves,peg_len * 2);
}
